#!/usr/bin/env node

/*
 * Copyright (c) 2018, salesforce.com, inc.
 * All rights reserved.
 * SPDX-License-Identifier: MIT
 * For full license text, see the LICENSE file in the repo root or https://opensource.org/licenses/MIT
 */
'use strict';

const execSync = require('child_process').execSync;

const output = execSync('git status --porcelain').toString();

let lines = output.split('\n');
lines = lines.filter(line => line.length);

if (lines.length > 0) {
    console.log('Uncommitted local changes:\n', output);
    throw new Error('Uncommitted local changes. Resolve before publishing.');
}
